<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題6.16 - 標準写像 &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題12.1 - 離散的な時間の1次元ランダムウォーク" href="../12-1_random_walk_d1/12-1.html" />
    <link rel="prev" title="問題6.14 - 外力を受けた減衰振り子" href="../6-14_poincare/6-14.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../12-1_random_walk_d1/12-1.html" title="問題12.1 - 離散的な時間の1次元ランダムウォーク"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../6-14_poincare/6-14.html" title="問題6.14 - 外力を受けた減衰振り子"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題6.16 - 標準写像</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題6.16 - 標準写像</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>標準写像</p>
<div class="math" id="equation-s1">
<p><span class="eqno">(1)</span><img src="../_images/math/41dc4d791ea1a0a0c7fbcf243fbddb605ef17a44.png" alt="\theta_{n+1} = (\theta_{n} + p_{n}) \qquad \mathrm{modulo} 2\pi"/></p>
</div><div class="math" id="equation-s2">
<p><span class="eqno">(2)</span><img src="../_images/math/7d702456aaef9c23df5f8e16f245845bcd93b8c2.png" alt="p_{n+1} = p_{n} + k \sin \theta_{n+1}"/></p>
</div><p>は、ハミルトン系の中でも、ある初期状態では規則的で可積分であるが他の条件ではカオス的になるという、混合系ともいえるクラスの単純なモデルである。物理的な実体としては、<a class="reference internal" href="#fig-6-16-f1"><em>図1</em></a>に示されているような回転子を考えている。慣性モーメント<img class="math" src="../_images/math/5d9e7b2aec3287330051a115f2ea3cdc8c7a6587.png" alt="I"/>、長さ<img class="math" src="../_images/math/0a5711c7a37994043b2bc3bb374adca232491762.png" alt="L"/>の棒の一端が摩擦のない支点に固定されていて、他端には強さ<img class="math" src="../_images/math/326154a3513d7ec61c6a7d02880e96c94831d98b.png" alt="k/L"/>の周期的な撃力が、時刻<img class="math" src="../_images/math/4560fce588a778e44a574aa74ac70cfc839ae493.png" alt="t=0,\tau,2\tau, \cdots"/>に鉛直方向に加えられる。回転子の運動は角度<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>とそれに対応する角運動量<img class="math" src="../_images/math/a42222f7f6b51d46dc562eb672fe888ba6f0738c.png" alt="p_{\theta}"/>で記述される。この系のハミルトニアンは</p>
<div class="math">
<p><img src="../_images/math/8de58c9dcf94cbbe866f3eb1c6232d1bf56d6fc4.png" alt="H(\theta, p_{\theta}, t) = \frac{p_{\theta}^{2}}{2I} + k \cos \theta \sum_{n} \delta (t-n\tau)"/></p>
</div><p>と書かれる。したがって、対応する運動方程式は、正準方程式を用いて</p>
<div class="math" id="equation-e1">
<p><span class="eqno">(3)</span><img src="../_images/math/ab274b4908522583a041a424607fb54743e467a4.png" alt="\frac{dp_{\theta}}{dt} = k\sin \theta \sum_{n} \delta (t- n\tau)"/></p>
</div><div class="math" id="equation-e2">
<p><span class="eqno">(4)</span><img src="../_images/math/8c05ab3d674005f3ad5642459aa42f5b30ea9df6.png" alt="\frac{d\theta}{dt} = \frac{p_{\theta}}{I}"/></p>
</div><p>となる。式<a href="#equation-e1">(3)</a>、<a href="#equation-e2">(4)</a>から、<img class="math" src="../_images/math/a42222f7f6b51d46dc562eb672fe888ba6f0738c.png" alt="p_{\theta}"/>は撃力とつぎの撃力の間では一定(重力はないと仮定している)であるが、撃力が加わるときに不連続的に変化することがわかる。角度<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>は撃力と撃力の間で<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>の1次で変化し、撃力が加わる瞬間では連続である。
撃力を加えた直後の<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/a42222f7f6b51d46dc562eb672fe888ba6f0738c.png" alt="p_{\theta}"/>の値を求めると都合がよい。<img class="math" src="../_images/math/440a05eff1adc0693e10a2fb6d0c6da133501cdc.png" alt="\varepsilon&gt;0"/>を微小量として<img class="math" src="../_images/math/1d4fc0cd0c4f561bb95b4c42a3fde0fc745132d3.png" alt="t=n\tau + \varepsilon"/>における<img class="math" src="../_images/math/48dc560f5a5493da991217faf0ce2e4541257892.png" alt="\theta(t)"/>および<img class="math" src="../_images/math/b503ac357e6edf633f2cc8a95579d19bcf19625b.png" alt="p_{\theta}(t)"/>の値をそれぞれ<img class="math" src="../_images/math/8dde6491a72f20e330645fd6d22ab502ae8e892d.png" alt="\theta_{n}"/>および<img class="math" src="../_images/math/aff1a67b58b69deb68d315c3b718c7a479ebcd53.png" alt="p_{n}"/>とする。式<a href="#equation-e1">(3)</a>を<img class="math" src="../_images/math/2e1a0ca07a95d0835c7593fd415bdd18f749ab84.png" alt="t=(n+1)\tau-\varepsilon"/>から<img class="math" src="../_images/math/2e1a0ca07a95d0835c7593fd415bdd18f749ab84.png" alt="t=(n+1)\tau-\varepsilon"/>まで積分すると、</p>
<div class="math">
<p><img src="../_images/math/e57e0d528004b497a2dd7312c00c2a5a0484df74.png" alt="p_{n+1} - p_{n}= k\sin \theta_{n+1}"/></p>
</div><p>を得る(<img class="math" src="../_images/math/3eca8557203e86160952e1c0f735f7417f3285b1.png" alt="p"/>は撃力と撃力の間で一定であり、<img class="math" src="../_images/math/6de56992570150c797b8a84a58899a6e7c8093b2.png" alt="t=(n+1)\tau"/>のときにのみデルタ関数が積分に寄与することに注意が必要である)。式<a href="#equation-e2">(4)</a>からは</p>
<div class="math">
<p><img src="../_images/math/96ad3be0c2159e8a99cd17c1e1d807bc0a51c01f.png" alt="\theta_{n+1} - \theta_{n} = (\tau/I)p_{n}"/></p>
</div><p>が得られる。<img class="math" src="../_images/math/e44424ffea91b2c4324bbad30c71c330f09681c5.png" alt="\tau/I = 1"/>となるように単位を選ぶと、標準写像<a href="#equation-s1">(1)</a>,<a href="#equation-s2">(2)</a>が得られる。式<a href="#equation-s1">(1)</a>には角度<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/> の値が<img class="math" src="../_images/math/74c081db590f3d35421c1f6b9afd4cdda36ee210.png" alt="0"/>と<img class="math" src="../_images/math/9871bd64995368def3d10c85692a233e4cb5e3f9.png" alt="2\pi"/>の間に制限されるという条件(modulo <img class="math" src="../_images/math/9871bd64995368def3d10c85692a233e4cb5e3f9.png" alt="2\pi"/>)を付け加えてある。</p>
<div class="align-center figure" id="fig-6-16-f1">
<a class="reference internal image-reference" href="../_images/figure_13.png"><img alt="../_images/figure_13.png" src="../_images/figure_13.png" style="width: 10.5cm;" /></a>
<p class="caption">撃力が加えられた慣性モーメント<img class="math" src="../_images/math/5d9e7b2aec3287330051a115f2ea3cdc8c7a6587.png" alt="I"/>の棒からなる回転子。重力と支点での摩擦は無視する。</p>
</div>
<p>式<a href="#equation-s1">(1)</a>,<a href="#equation-s2">(2)</a>の反復計算を行う前に、これらがハミルトン系、つまり<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>を大きくしていっても<img class="math" src="../_images/math/23f1b45408e5b4130c0f940fcbfcec54492cbdcd.png" alt="q"/>-<img class="math" src="../_images/math/3eca8557203e86160952e1c0f735f7417f3285b1.png" alt="p"/>空間における面積が一定であることを確かめておく(ここでは<img class="math" src="../_images/math/23f1b45408e5b4130c0f940fcbfcec54492cbdcd.png" alt="q"/>は<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>を指している)。長さ<img class="math" src="../_images/math/c0c84db93d7706fed3c05d20252e199368fa4bf7.png" alt="dq_{n}"/>と<img class="math" src="../_images/math/da555e61e40a22976d3a4518fa9340ecea110d93.png" alt="dp_{n}"/>の長方形から始めることを考えると、1回の反復の後、この長方形は<img class="math" src="../_images/math/df573dbf2446cb5eef9ddefcee6398a6e6b4ed12.png" alt="dq_{n+1}"/>と<img class="math" src="../_images/math/ab577fca8804b676b09dbc831b92bd26719dcd1a.png" alt="dp_{n+1}"/>の辺を持つ平行四辺形に変形される。すなわち、</p>
<div class="math" id="equation-e3">
<p><span class="eqno">(5)</span><img src="../_images/math/e76537722e4fb6f88886198f31d8f185e0cd5755.png" alt="dq_{n+1} = dq_{n} + dp_{n}"/></p>
</div><div class="math" id="equation-e4">
<p><span class="eqno">(6)</span><img src="../_images/math/933e39c5495ec3488c6492c88d777d346e2b1ee1.png" alt="dp_{n+1} = dp_{n} + k \cos q_{n+1} dq_{n+1}"/></p>
</div><p>である。式<a href="#equation-e3">(5)</a>に<a href="#equation-e4">(6)</a>を代入すると、</p>
<div class="math">
<p><img src="../_images/math/3eacdc1a2e60c34111b9eaf9b6833826f6444c23.png" alt="dp_{n+1} = (1 + k \cos q_{n+1})dp_{n} + k\cos q_{n+1} dq_{n}"/></p>
</div><p>を得る。ベクトル<img class="math" src="../_images/math/3c457ab855db31b4f6e94315ab848a4e837c6b0d.png" alt="d\mbox{\boldmath $q$}_{n+1} = (dq_{n}, dp_{n})"/>と<img class="math" src="../_images/math/8db3983b07d76884e7937000cb588254b99bce69.png" alt="d\mbox{\boldmath $p$}_{n+1} = (1 + k\cos q_{n}, k\cos q_{n} dq_{n}))"/>のベクトル積の大きさを計算して平行四辺形の面積を求めると、<img class="math" src="../_images/math/a7df5f76eee913462dc92112a7333f709cb3bca9.png" alt="dq_{n}dp_{n}"/>となり、位相空間内の面積は不変であり、標準写像は保存系であることがわかる。
標準写像の定性的性質については問題6.16で調べることであるが、それらは次のように要約することができる。<img class="math" src="../_images/math/d85fd3ecb4c7dd371fbf412352b67be347043fba.png" alt="k=0"/>のとき、棒は運動量<img class="math" src="../_images/math/e110dd146e1fe1a72fea95dbfd7790f1f12141e1.png" alt="p_{n} = p_{0} ="/>一定によって定まる一定の角運動量で回転する。<img class="math" src="../_images/math/db9883d64206b66186d6d083bca6c6e2151e6ce5.png" alt="p_{0}"/>が<img class="math" src="../_images/math/9871bd64995368def3d10c85692a233e4cb5e3f9.png" alt="2\pi"/>の有理数倍のときには、位相空間の軌跡は、水平な線上にある孤立した点列から構成される(共鳴トーラス)。<img class="math" src="../_images/math/db9883d64206b66186d6d083bca6c6e2151e6ce5.png" alt="p_{0}"/>が<img class="math" src="../_images/math/9871bd64995368def3d10c85692a233e4cb5e3f9.png" alt="2\pi"/>の有理数倍でないか、コンピュータに十分な精度がないときには、十分に長い時間の後に軌跡は位相空間内の水平な曲線へと変化する。そして共有トーラスに対応する孤立した点列は閉曲線へと変化する。初期条件によっては、過渡的な振る舞いが消えるくらいに十分長い反復の後に、軌跡はカオス的になるだろう。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションで作成・使用したプログラムを以下に示す。</p>
<ul class="simple">
<li>パラメータの設定ウィンドウ( <a class="reference download internal" href="../_downloads/SetParameter2.py"><tt class="xref download docutils literal"><span class="pre">SetParameter.py</span></tt></a> )</li>
</ul>
<p><a class="reference internal" href="../6-14_poincare/6-14.html#label"><em>問題6.14</em></a> で使用したものと同じである。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, Mqy 2014.</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">SetParameter</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_setting_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parameters</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a parameter setting window.</span>
<span class="sd">                </span>
<span class="sd">        parameters: A list of dictionaries {&#39;parameter name&#39;:default_value}</span>
<span class="sd">        commands: A list of dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Parameter&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">parameter</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">parameters</span><span class="p">):</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s">&#39; = &#39;</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">sticky</span><span class="o">=</span><span class="n">E</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Entry</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">10</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">END</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">focus_set</span><span class="p">()</span>
       
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">button</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">commands</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">button</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">command</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span>
                                      <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
                                      <span class="p">)</span>
                               <span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">button</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="n">i</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>標準写像の計算・描画プログラム( <a class="reference download internal" href="../_downloads/6-16_standard_map.py"><tt class="xref download docutils literal"><span class="pre">6-16_standard_map.py</span></tt></a> )</li>
</ul>
<p>このプログラムでは、初めのntransient回の計算結果を捨てて、nplot回の反復計算の結果をグラフに表示するプログラムである。プログラムを実行すると、SetParameterのshow_setting_windowが呼び出され、パラメータの設定が行える。OKボタンを押すと、関数staticを介してパラメータの代入とグラフの描画を行う。ここでのカウンタはscatterメソッドが標準で色のループを行わないため、自前で色の制御を行うために追加したものである。実際に写像の計算を行っているのは50行目から63行目であり、あとはグラフの体裁を整えるためのものである。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="n">sin</span><span class="p">,</span> <span class="n">pi</span>
<span class="kn">from</span> <span class="nn">SetParameter</span> <span class="kn">import</span> <span class="n">SetParameter</span>
<span class="kn">from</span> <span class="nn">array</span> <span class="kn">import</span> <span class="n">array</span>
<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="c"># --- init ---</span>
<span class="n">counter</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">colors</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;blue&#39;</span><span class="p">,</span> <span class="s">&#39;green&#39;</span><span class="p">,</span> <span class="s">&#39;red&#39;</span><span class="p">,</span> <span class="s">&#39;purple&#39;</span><span class="p">,</span> <span class="s">&#39;black&#39;</span><span class="p">]</span>
<span class="n">ntransient</span> <span class="o">=</span> <span class="mi">1000</span>
<span class="n">nplot</span> <span class="o">=</span> <span class="mi">10000</span>
<span class="n">nmax</span> <span class="o">=</span> <span class="n">ntransient</span> <span class="o">+</span> <span class="n">nplot</span>
<span class="n">max_p</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">min_p</span> <span class="o">=</span> <span class="mi">0</span>

<span class="c"># --- prepare figure and axes ---</span>
<span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">12</span><span class="p">,</span> <span class="mi">6</span><span class="p">),</span> <span class="n">dpi</span><span class="o">=</span><span class="mi">80</span><span class="p">)</span>
<span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">bottom</span><span class="o">=</span><span class="mf">0.14</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">right</span><span class="o">=</span><span class="mf">0.68</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">()</span>

<span class="k">def</span> <span class="nf">static</span><span class="p">():</span>
    <span class="k">global</span> <span class="n">counter</span>
    <span class="n">assignment</span><span class="p">()</span>

    <span class="n">color</span> <span class="o">=</span> <span class="n">colors</span><span class="p">[</span><span class="n">counter</span><span class="p">]</span>
    <span class="n">counter</span> <span class="o">+=</span> <span class="mi">1</span>
    <span class="k">if</span> <span class="n">counter</span> <span class="o">&gt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">colors</span><span class="p">):</span>
        <span class="n">counter</span> <span class="o">=</span> <span class="n">counter</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">colors</span><span class="p">)</span>
    
    <span class="n">plot_static</span><span class="p">(</span><span class="n">theta</span><span class="p">,</span> <span class="n">ang_mom</span><span class="p">,</span> <span class="n">color</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Assign the values to variables and plot the map.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">theta</span><span class="p">,</span> <span class="n">ang_mom</span><span class="p">,</span> <span class="n">k</span><span class="p">,</span> <span class="n">color</span>
    <span class="n">theta</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ang_mom</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">k</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>

<span class="k">def</span> <span class="nf">plot_static</span><span class="p">(</span><span class="n">q</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span> <span class="n">color</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Show an standard map.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">max_p</span><span class="p">,</span> <span class="n">min_p</span>
    <span class="c"># --- Caluculating ---</span>
    <span class="n">ary_q</span> <span class="o">=</span> <span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">ary_p</span> <span class="o">=</span> <span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">ary_q</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">q</span><span class="p">)</span>
    <span class="n">ary_p</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>
        
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nmax</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">_q</span> <span class="o">=</span> <span class="n">ary_q</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">+</span> <span class="n">ary_p</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="c"># 0 &lt;= theta &lt;= 2*pi</span>
        <span class="k">while</span> <span class="n">_q</span> <span class="o">&gt;</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span><span class="p">:</span>
            <span class="n">_q</span> <span class="o">=</span> <span class="n">_q</span> <span class="o">-</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
        <span class="k">while</span> <span class="n">_q</span> <span class="o">&lt;</span> <span class="mf">0.</span><span class="p">:</span>
            <span class="n">_q</span> <span class="o">=</span> <span class="n">_q</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
        <span class="n">ary_q</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">_q</span><span class="p">)</span>
        <span class="n">ary_p</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ary_p</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">+</span> <span class="n">k</span><span class="o">*</span><span class="n">sin</span><span class="p">(</span><span class="n">ary_q</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">+</span> <span class="n">ary_p</span><span class="p">[</span><span class="n">i</span><span class="p">]))</span>
    
    <span class="c"># --- Set labels and ticks. ---</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$\theta$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$p_{\theta}$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Standard map&#39;</span><span class="p">)</span>        
    <span class="n">unit</span>   <span class="o">=</span> <span class="mf">0.5</span>
    <span class="n">q_tick</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mf">2.0</span><span class="o">+</span><span class="n">unit</span><span class="p">,</span> <span class="n">unit</span><span class="p">)</span>
    <span class="n">q_label</span> <span class="o">=</span> <span class="p">[</span><span class="s">r&quot;$0$&quot;</span><span class="p">,</span><span class="s">r&quot;$\frac{1}{2}\pi$&quot;</span><span class="p">,</span><span class="s">r&quot;$\pi$&quot;</span><span class="p">,</span><span class="s">r&quot;$\frac{3}{2}\pi$&quot;</span><span class="p">,</span><span class="s">r&quot;$2\pi$&quot;</span><span class="p">]</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xticks</span><span class="p">(</span><span class="n">q_tick</span><span class="o">*</span><span class="n">pi</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">(</span><span class="n">q_label</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">18</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">max</span><span class="p">(</span><span class="n">ary_p</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:])</span> <span class="o">&gt;</span> <span class="n">max_p</span><span class="p">:</span>
        <span class="n">max_p</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">ary_p</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:])</span>
    <span class="k">if</span> <span class="nb">min</span><span class="p">(</span><span class="n">ary_p</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:])</span> <span class="o">&lt;</span> <span class="n">min_p</span><span class="p">:</span>
        <span class="n">min_p</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">ary_p</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:])</span>
    <span class="n">margin</span> <span class="o">=</span>  <span class="p">(</span><span class="n">max_p</span><span class="o">-</span><span class="n">min_p</span><span class="p">)</span><span class="o">*</span><span class="mf">0.05</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylim</span><span class="p">(</span><span class="n">min_p</span><span class="o">-</span><span class="n">margin</span><span class="p">,</span> <span class="n">max_p</span><span class="o">+</span><span class="n">margin</span><span class="p">)</span>
    
    <span class="c"># --- Plot the standard map. ---    </span>
    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">ary_q</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:],</span> <span class="n">ary_p</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:],</span>
               <span class="n">s</span><span class="o">=</span><span class="mf">2.0</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">color</span><span class="p">,</span>
               <span class="n">label</span><span class="o">=</span><span class="s">r&#39;$\theta_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">theta</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
               <span class="o">+</span> <span class="s">r&#39;$p_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">ang_mom</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
               <span class="o">+</span> <span class="s">r&#39;$k=$&#39;</span> <span class="o">+</span> <span class="nb">repr</span><span class="p">(</span><span class="n">k</span><span class="p">)</span>
               <span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">bbox_to_anchor</span><span class="o">=</span><span class="p">(</span><span class="mf">1.05</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">),</span> <span class="n">loc</span><span class="o">=</span><span class="s">&#39;upper left&#39;</span><span class="p">,</span> <span class="n">borderaxespad</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
    <span class="n">window</span> <span class="o">=</span> <span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">default_params</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;theta&#39;</span><span class="p">:</span><span class="mf">1.5</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;p&#39;</span><span class="p">:</span><span class="mf">0.2</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;k&#39;</span><span class="p">:</span><span class="mf">0.1</span><span class="p">}]</span>
    <span class="n">commands</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">static</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;EXIT&#39;</span><span class="p">:</span><span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">}]</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">default_params</span><span class="p">,</span> <span class="n">commands</span><span class="p">)</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li>標準写像の反復を実行するプログラムを書いて、位相空間の軌跡を描け。<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>を変えたときの挙動を調べよ。特に、位相空間内の軌道の変化に着目せよ。</li>
</ol>
<p>まず、単純な問題として<img class="math" src="../_images/math/d85fd3ecb4c7dd371fbf412352b67be347043fba.png" alt="k=0"/>として固定したとき、初期条件<img class="math" src="../_images/math/db9883d64206b66186d6d083bca6c6e2151e6ce5.png" alt="p_{0}"/>の値をさまざまに変えたときの軌跡の様子を<a class="reference internal" href="#fig-6-16-f2"><em>図2</em></a>に示す。この図は、周期的な撃力がないときには、棒は初めの角運動量を保ったまま回転を続けるという事実を再現している。</p>
<div class="align-center figure" id="fig-6-16-f2">
<a class="reference internal image-reference" href="../_images/figure_22.png"><img alt="../_images/figure_22.png" src="../_images/figure_22.png" style="width: 16.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/d85fd3ecb4c7dd371fbf412352b67be347043fba.png" alt="k=0"/>のときの位相空間の軌跡</p>
</div>
<p>次に、<img class="math" src="../_images/math/db0907f5fd9e9e5583bdabc8301d6d42ccecea81.png" alt="\theta_{0}"/>と<img class="math" src="../_images/math/db9883d64206b66186d6d083bca6c6e2151e6ce5.png" alt="p_{0}"/>を固定して、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>を<img class="math" src="../_images/math/165a51ef627fed6b8bffa803d09960563015e702.png" alt="k=0.1, 1.0, 1.7, 1.99694994, 1.99694995, 2.0"/>としたときの位相空間の軌跡を<a class="reference internal" href="#fig-6-16-f3"><em>図3</em></a>、<a class="reference internal" href="#fig-6-16-f4"><em>図4</em></a>に示す。このグラフから、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>が大きくなるにつれて曲線や閉曲線であった軌跡が分岐していくようになり、トーラスの島と呼ばれる環状の軌跡が現れる様子も観察される。また、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>がある値<img class="math" src="../_images/math/c740095a33a03069725db19dddddf97adb9bad94.png" alt="k=k_{c} \simeq 1.99694995"/>以上になると、その曲線からさらに離れた位置を取るようになって、カオス的な振る舞いを示すことも分かる。この<img class="math" src="../_images/math/1cc2532a0eaa7fa48c3fc947a7a0403e61b83273.png" alt="k_{c}"/>の値は、初期値によって変わることも確かめることができた。</p>
<div class="align-center figure" id="fig-6-16-f3">
<a class="reference internal image-reference" href="../_images/figure_31.png"><img alt="../_images/figure_31.png" src="../_images/figure_31.png" style="width: 16.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/5b97f1f31e950b4c1b0b2c875f0691087d9652c8.png" alt="\theta_{0}=1.5"/>、<img class="math" src="../_images/math/7dfdff5bb5a435872493ebd5d0780b9b447e8609.png" alt="p_{0}=0.2"/>としたとき、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>による位相空間での軌跡の変化</p>
</div>
<div class="align-center figure" id="fig-6-16-f4">
<a class="reference internal image-reference" href="../_images/figure_4.png"><img alt="../_images/figure_4.png" src="../_images/figure_4.png" style="width: 16.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/5b97f1f31e950b4c1b0b2c875f0691087d9652c8.png" alt="\theta_{0}=1.5"/>、<img class="math" src="../_images/math/7dfdff5bb5a435872493ebd5d0780b9b447e8609.png" alt="p_{0}=0.2"/>としたとき、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>による位相空間での軌跡の変化</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>ハミルトン系の単純な例である標準写像について、<img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/>による位相空間での軌跡の変化を観察することができた。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題6.16 - 標準写像</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../6-14_poincare/6-14.html"
                        title="前の章へ">問題6.14 - 外力を受けた減衰振り子</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../12-1_random_walk_d1/12-1.html"
                        title="次の章へ">問題12.1 - 離散的な時間の1次元ランダムウォーク</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-16_standard_map/6-16.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../12-1_random_walk_d1/12-1.html" title="問題12.1 - 離散的な時間の1次元ランダムウォーク"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../6-14_poincare/6-14.html" title="問題6.14 - 外力を受けた減衰振り子"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>